unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const pn=4;
      scale=20;
      pontSz=90;
var
  Form1: TForm1;
  kp   : Array [1..pn] of TPoint;   //A pontok tmbje
  kivalasztott   : integer;         //A kivlasztott pont mozgathat
  i              : word;
  step, t        : real;
  xc, yc, xk, yk : integer;

Implementation
{$R *.DFM}

Function sk(x : real; n : word) : real;
var
  nt     : word;
  res    : real;
begin
 res    := 1;
 for nt := 1 to n do
     res:= res * x;
     sk := res;
end;

Procedure Bezier(t : real; var x, y : integer);
begin
 // r(u)=((1-t)^3)P0+(3t(1-t)^2)P1+3(t^2)(1-t)P2+(t^3)P3
 x := round(sk(1-t,3)*kp[1].X+3*t*sk(1-t,2)*+kp[2].X+3*t*t*(1-t)*kp[3].X+sk(t,3)*kp[4].X);
 y := round(sk(1-t,3)*kp[1].Y+3*t*sk(1-t,2)*+kp[2].Y+3*t*t*(1-t)*kp[3].Y+sk(t,3)*kp[4].Y);
end;

Function Pontkeres(x,y:integer):integer;
// A fggvny kikeresi az x,y ponthoz legkzelebbi sarokpontot
var tav,tav1,tav2,tav12:real;
    i:integer;
begin
   tav:=10000;
   Pontkeres:=-1;
   for i:=1 to pn do
     begin
       tav1:=(kp[i].x-x);
       tav2:=(kp[i].y-y);
       tav1:=tav1*tav1;
       tav2:=tav2*tav2;
       tav12:=tav1+tav2;
       if tav12<tav then
         begin
           tav:=tav12;
           Pontkeres:=i;
         end;
     end;
end;
procedure TForm1.FormCreate(Sender: TObject);

begin
   // Ltrehozzuk az alapbra pontjait
   xk:=ClientWidth  div 2; yk:=ClientHeight div 2;
   kp[1].x:=xk+(-9*scale); kp[1].y:=yk-(0*scale) ;
   kp[2].x:=xk+(-4*scale); kp[2].y:=yk-(0*scale) ;
   kp[3].x:=xk+(4*scale);  kp[3].y:=yk-(0*scale) ;
   kp[4].x:=xk+(9*scale);  kp[4].y:=yk-(0*scale) ;
   kivalasztott:=-1;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  Canvas.pen.color:=clBlue;
  t:=0;
      Step:=1/PontSz;
      Canvas.MoveTo(kp[1].x,kp[1].y);
      while t<1 do
      begin
        Bezier(t,xc,yc);
        Canvas.LineTo(xc,yc);
                   t:=t+step;
        end;
        Canvas.MoveTo(kp[4].x,kp[4].y);
        Canvas.pen.color:=clBlack; Canvas.Polyline(kp);
  For i:=1 to pn do Canvas.Ellipse(kp[i].x-4,kp[i].y-4,kp[i].x+5,kp[i].y+5);
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  //Gombnyomssal pontot vlasztunk
  kivalasztott:=Pontkeres(x,y);
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  // Ha elengedjk az egrgombot nincs kivlasztott pont
  kivalasztott:=-1;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
   // Ha van kivlasztott pont (lenyomott egrgomb), akkor az mozog
   if (kivalasztott>-1) then
     begin
  // Az elso s az utolso pont rogzitett
       if (kivalasztott<>0) and (kivalasztott<>pn+1) then
        begin
         kp[kivalasztott].x:=x;
         kp[kivalasztott].y:=y;
        end;
      Refresh;
     end;
end;

End.
