//============================================================
// NURBS APPLET
//
// Szirmay-Kalos Laszlo, 2000
//============================================================
import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;


//--------------------------------------------
public class Nurbs extends Applet {
//--------------------------------------------
        class Vector {
                double x, y;
                Vector( ) { x = y = 0; }
                Vector( double x0, double y0 ) { x = x0; y = y0; }
                void Add( Vector v ) { x += v.x; y += v.y; }
                Vector Mul( double s ) {
                        return new Vector(x * s, y * s);
                }
        }

        Vector r[];
        double t[], w[];
        int     N = 2, n = -1;

        double tknot(int i)  {
                if (i < N) return 0;
                if (i > n) return (n - N + 2.00001);
                return (i - N + 1);
        }

        double B(int i, int k, double t) {
                if (k == 1)  {
                        if (tknot(i) <= t && t < tknot(i+1)) return 1;
                        else  return 0;
                }

                double b1 = B(i, k-1, t);
                double dt = (tknot(i+k-1) - tknot(i));
                if (dt > 0.00001) b1 /= dt;
                else b1 = 0;

                double b2 = B(i+1, k-1, t);
                dt = (tknot(i+k) - tknot(i+1));
                if (dt > 0.000001) b2 /= dt;
                else b2 = 0;

                return ( (t-tknot(i))*b1 + (tknot(i+k)-t)* b2);
        }

        Vector NURBS(int k, double t) {
                Vector rt = new Vector();
                double ws = 0;
                for(int i = 0; i <= n; i++) {
                        double ww = B(i, k, t);
                        ws += ww;
                        rt.Add( r[i].Mul( ww ) );
                }
                return rt;
        }

        TextField degfield;

      public void init( ) {
                r = new Vector[100];
                t = new double[100];
                w = new double[100];

                add( new Label("Degree: ") );
                degfield = new TextField( String.valueOf(N), 20 );
                add( degfield );

        // controller inicializlsa

                class CRListener extends KeyAdapter { // a text mez megvltozsnak kezelse
                public void keyPressed( KeyEvent e ) {
                              int key = e.getKeyCode();
                                if (key == KeyEvent.VK_ENTER) {
                                        N = Integer.valueOf( degfield.getText() ).intValue();
                                        if (N == 0) {
                                                n = -1;
                                                repaint( );                             // rajzols
                                        } else {
                                                Graphics gc = getGraphics();
                                                for(int i = 0; i < (n-N+2) * 10; i++) {
                                                        if (i/10 == 0) gc.setColor( new Color(255, 0, 0) );
                                                        if (i/10 == 1) gc.setColor( new Color(0, 255, 0) );
                                                        if (i/10 == 2) gc.setColor( new Color(0, 0, 255) );
                                                        if (i/10 == 3) gc.setColor( new Color(127, 127, 0) );
                                                        if (i/10 == 4) gc.setColor( new Color(0, 127, 127) );
                                                        if (i/10 == 5) gc.setColor( new Color(127, 0, 127) );
                                                        if (i/10 == 6) gc.setColor( new Color(255, 0, 0) );
                                                        if (i/10 == 7) gc.setColor( new Color(0, 255, 0) );
                                                        if (i/10 == 8) gc.setColor( new Color(0, 0, 255) );
                                                        if (i/10 == 9) gc.setColor( new Color(127, 127, 0) );
                                                        if (i/10 == 10) gc.setColor( new Color(0, 127, 127) );
                                                        if (i/10 == 11) gc.setColor( new Color(127, 0, 127) );
                                                        Vector start = NURBS(N, i/10.);
                                                        Vector end = NURBS(N, (i+1)/10.);
                                                        gc.drawLine((int)start.x, (int)start.y, (int)end.x, (int)end.y);
                                                }
                                        }
                                }
                  }
            }
                degfield.addKeyListener( new CRListener() );

        // egr klitty kezelse
                class MyMouseListener extends MouseAdapter {
                        public void mousePressed( MouseEvent e ) {
                                                        // kp -> modell transzformci
                                n++;
                                r[n] = new Vector((double)e.getX(), (double)e.getY());
                                w[n] = 1;
                                t[n] = n;
                                repaint( );                             // rajzols
                        }
                }
                addMouseListener( new MyMouseListener() );
      }

      public void paint( Graphics gc ) {
                for(int i = 0; i <= n; i++) {
                        gc.fillOval((int)r[i].x-5, (int)r[i].y-5, 10, 10);
                }
                for(int i = 0; i < (n-N+2) * 10; i++) {
                                                        if (i/10 == 0) gc.setColor( new Color(255, 0, 0) );
                                                        if (i/10 == 1) gc.setColor( new Color(0, 255, 0) );
                                                        if (i/10 == 2) gc.setColor( new Color(0, 0, 255) );
                                                        if (i/10 == 3) gc.setColor( new Color(127, 127, 0) );
                                                        if (i/10 == 4) gc.setColor( new Color(0, 127, 127) );
                                                        if (i/10 == 5) gc.setColor( new Color(127, 0, 127) );
                                                        if (i/10 == 6) gc.setColor( new Color(255, 0, 0) );
                                                        if (i/10 == 7) gc.setColor( new Color(0, 255, 0) );
                                                        if (i/10 == 8) gc.setColor( new Color(0, 0, 255) );
                                                        if (i/10 == 9) gc.setColor( new Color(127, 127, 0) );
                                                        if (i/10 == 10) gc.setColor( new Color(0, 127, 127) );
                                                        if (i/10 == 11) gc.setColor( new Color(127, 0, 127) );
                        Vector start = NURBS(N, i/10.);
                        Vector end = NURBS(N, (i+1)/10.);
                        gc.drawLine((int)start.x, (int)start.y, (int)end.x, (int)end.y);
                }
        }
}

