{$N+}
Program Coons_Hermite;

Uses Graph;

Const
      pn = 8;
   scale = 20;
  PontSz = 200;

Type
  pont2D = record
                  X,Y : longint;
           end;

Var
   kp,ep    : Array[1..pn] of Pont2D;  {Kontrol Pontok}
   k0       : real  ;
   ch       : char  ;
   k,i      : word  ;
   ks       : string;


Function ReadKey:Char; Assembler;
 asm
  xor ah,ah
  int 16h
 end;

Procedure VideoInit;
Var
  hibakod,gd,gm : integer;
  begin
   gd:=detect;
   InitGraph(gd,gm,'') ;
   hibakod:=graphresult;
   if hibakod<>0 then begin
                        writeln('Grafikus hiba: ',GraphErrorMsg(hibakod));
                        halt(1);
                      end;
   end;

Procedure F_koor;
Var i:integer;
  begin
    SetBKColor(0);
    SetColor(white);

    OutTextXY(10,10,'3Dimenzios grafika alapjai');
    OutTextXY(10,20,'Coons-Hermite interpolci');
    OutTextxy(325,10, 'y');OutTextxy(630,250,'x');
    SetColor(2);
    Line(320,0,320,480)  ; Line(0,240,640,240)   ;
    Line(317,7,320,0)    ; Line(320,0,323,7)     ;
    Line(633,236,640,240); Line(633,244,640,240) ;

    i:=0;
    while i<640 do begin
      line(i,238,i,242);
      i:=i+scale;
    end;
    i:=20;
    while i<480 do begin
      line(318,i,322,i);
      i:=i+scale;
    end;

end;

Procedure ErintoSz; {Erinto szamitas}
begin
  case ch of
  'N':begin {nylt grbe esetre}
          ep[1].x:=round( (kp[2].x-kp[1].x )*k0);
          ep[1].y:=round( (kp[2].y-kp[1].y )*k0);
       ep[pn].x:=round((kp[pn].x-kp[pn-1].x)*k0);
       ep[pn].y:=round((kp[pn].y-kp[pn-1].y)*k0);
      end;
  'Z':begin {zrt grbe esetre}
          ep[1].x:=round((kp[2].x-kp[pn].x)*k0);
          ep[1].y:=round((kp[2].y-kp[pn].y)*k0);
       ep[pn].x:=round((kp[1].x-kp[pn-1].x)*k0);
       ep[pn].y:=round((kp[1].y-kp[pn-1].y)*k0);
      end;
  end;

  for k:=2 to pn-1 do begin  {mindkt grbe esetn ugyan az}
                       ep[k].x:=round((kp[k+1].x-kp[k-1].x)*k0);
                       ep[k].y:=round((kp[k+1].y-kp[k-1].y)*k0);
                      end;
end;

procedure CoonsHGr;

var
  j: integer;
  n, n2, n3, w, z: real;

function xp(i, j: integer): integer; {grbepont x koordintja}
begin
  case ch of
  'N':begin
      n:=j/PontSz; n2:=n*n; n3:=n2*n;
      xp:=round(((2*n3-3*n2+1)*kp[i].x+(-2*n3+3*n2)*kp[i+1].x+
                (n3-2*n2+n)*ep[i].x+(n3-n2)*ep[i+1].x)*scale);
    end;
  'Z':begin
      n:=j/PontSz; n2:=n*n; n3:=n2*n;
      if i=pn then
        xp:=round(((2*n3-3*n2+1)*kp[pn].x+(-2*n3+3*n2)*kp[1].x+
                   (n3-2*n2+n)*ep[pn].x+(n3-n2)*ep[1].x)*scale)
      else
        xp:=round(((2*n3-3*n2+1)*kp[i].x+(-2*n3+3*n2)*kp[i+1].x+
                  (n3-2*n2+n)*ep[i].x+(n3-n2)*ep[i+1].x)*scale);
    end;
  end;
end;

function yp(i, j: integer): integer; {grbepont y koordintja}
begin
  case ch of
  'N':begin
     n:=j/PontSz; n2:=n*n; n3:=n2*n;
     yp:=round(((2*n3-3*n2+1)*kp[i].y+(-2*n3+3*n2)*kp[i+1].y+
               (n3-2*n2+n)*ep[i].y+(n3-n2)*ep[i+1].y)*scale);
    end;
  'Z':begin
      n:=j/PontSz; n2:=n*n; n3:=n2*n;
      if i=pn then
        yp:=round(((2*n3-3*n2+1)*kp[pn].y+(-2*n3+3*n2)*kp[1].y+
                   (n3-2*n2+n)*ep[pn].y+(n3-n2)*ep[1].y)*scale)
      else
        yp:=round(((2*n3-3*n2+1)*kp[i].y+(-2*n3+3*n2)*kp[i+1].y+
                  (n3-2*n2+n)*ep[i].y+(n3-n2)*ep[i+1].y)*scale);
    end;
  end;
end;

begin
  SetColor(red);
  if ch='N' then Moveto(320+(kp[1].x*scale),240-(kp[1].y*scale));
  if ch='Z' then Moveto(320+xp(1,0),240-yp(1,0));
  for i:=1 to pn-1 do for j:=1 to PontSz do Lineto(320+xp(i,j), 240-yp(i,j));
  if ch='Z' then      for j:=1 to PontSz do Lineto(320+xp(pn,j),241-yp(pn,j));
end;

Begin
 VideoInit;
 F_koor; ch:='N';       k0:=1;
     kp[1].x:=1 ; kp[1].y:=-5;
     kp[2].x:=1 ; kp[2].y:=2 ;
     kp[3].x:=-7; kp[3].y:=1 ;
     kp[4].x:=-2; kp[4].y:=5 ;
     kp[5].x:=5 ; kp[5].y:=9 ;
     kp[6].x:=6 ; kp[6].y:=5 ;
     kp[7].x:=9 ; kp[7].y:=10;
     kp[8].x:=12; kp[8].y:=-3;

 ErintoSz;
 CoonsHGr;
 SetFillStyle(1,yellow);
      For i:=1 to pn do FillEllipse(320+(kp[i].x*scale),240-(kp[i].y*scale),3,3);
      ReadKey;
   CloseGraph;
End. of program